#modules/copymanager.py

import tkinter as tk  # For tkinter components
from tkinter import messagebox, ttk  # For messagebox and Treeview
import platform  # To check the operating system
import csv  # For handling CSV operations
import io  # For handling in-memory file operations
import pyperclip  # For clipboard handling (install using `pip install pyperclip` if not already installed)



class CopyManager: #원래 이거 자체가 한국어 키보드용..... 근데 트리뷰는 영어로 해도 여기가 불려옴
    COMMAND_KEY_MASK = 8  # Based on the state value provided
    SHIFT_KEY_MASK = 1  # Based on the state value provided
    TOGETHER_MASK = 9  # Based on the state value provided


    # Windows-specific masks
    WINDOWS_CONTROL = 4  # Control key state for Windows
    WINDOWS_SHIFT = 1  # Shift key state for Windows

    
    def __init__(self, parent_window):
        self.parent_window = parent_window
        #self.parent_window.bind("<KeyPress>", self.handle_keypress)
        
        self.clipboard_data = None
        self.last_system_clipboard = None

    ## 영어로 해도 이게 불려오네????
    def update_clipboard(self):
        current_system_clipboard = pyperclip.paste()
        if current_system_clipboard != self.last_system_clipboard:
            self.last_system_clipboard = current_system_clipboard
            try:
                csv_reader = csv.reader(io.StringIO(current_system_clipboard), delimiter='\t')
                self.clipboard_data = list(csv_reader)
            except:
                self.clipboard_data = None




    def handle_keypress(self, event):
        #print(event.state)
        #print(event.keycode)
        #print(event.keysym)

        # Copy (command+ㅊ)
        if event.keycode == 134217827 and (event.state & self.COMMAND_KEY_MASK):  # keycode for ㅊ
            #print("Copy text called")
            event.widget.event_generate("<<Copy>>")

        ######## 이게 ㅍ 보다 앞에 있어야 함. v를 먼저 막아야 함.
        elif event.keysym == 'v' and (event.state & self.COMMAND_KEY_MASK):  # keysym for 'v'
            # Do nothing, let the system handle the paste
            pass
            print("Ignoring system paste")
 
        # Paste (command+ㅍ)
        elif event.keycode == 150995062 and (event.state & self.COMMAND_KEY_MASK):  # keycode for ㅍ (v)
            print("Paste text called1")
            # Get the clipboard content
            try:
                clipboard_content = event.widget.clipboard_get()
                
                # Modify the clipboard content (e.g., replace '/i' with '\n')
                #modified_content = clipboard_content.replace('', '\n')
                modified_content = clipboard_content.replace("\u2028", "\n").replace("\u2029", "\n").replace("\f", "")

                # Set the modified content back to the clipboard
                event.widget.clipboard_clear()
                event.widget.clipboard_append(modified_content)
                
                # Now perform the paste operation
                event.widget.event_generate("<<Paste>>")
            except tk.TclError:
                # Handle empty clipboard
                print("Clipboard is empty or contains non-text data")




        # Select All (command+ㅁ)
        elif event.keycode == 97 and (event.state & self.COMMAND_KEY_MASK):  # keycode for ㅁ
            event.widget.event_generate("<<SelectAll>>")

        # Cut (command+ㅌ)
        elif event.keycode == 117440632 and (event.state & self.COMMAND_KEY_MASK):  # keycode for ㅌ
            event.widget.event_generate("<<Cut>>")



        # Windows-specific Redo (Ctrl+Shift+Z)
        elif event.keysym == 'Z' and (event.state & self.WINDOWS_CONTROL) and (event.state & self.WINDOWS_SHIFT):
            event.widget.event_generate("<<Redo>>") 
        


        # 일단 z를 막고 그 다음에 ㅋ
        elif event.keysym == 'z' and (event.state & self.COMMAND_KEY_MASK):  # keysym for 'z'
            # Do nothing, let the system handle the paste
            pass
            #print("Ignoring system paste")

        # Undo (command+ㅋ)
        elif event.keycode == 100663418 and (event.state & self.COMMAND_KEY_MASK):  # keycode for ㅋ
            print("실행취소")
            event.widget.event_generate("<<Undo>>")

        # Redo (command+shift+ㅋ)
        elif event.keycode == 104857722 and (event.state & self.COMMAND_KEY_MASK) and (event.state & self.SHIFT_KEY_MASK):  # keycode for ㅋ with Shift
            print("재실행")
            event.widget.event_generate("<<Redo>>")
        """
        # Redo (command+shift+ㅋ)
        elif event.keycode == 104857722 and (event.state & self.TOGETHER_MASK):  # keycode for ㅋ with Shift
            print("재실행")
            event.widget.event_generate("<<Redo>>")
        """

